/** **************************************************************************** 
 * This file is part of changedfiles
 * Copright (C)2001  Michael L. Welles 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at your option) 
 * any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/
#ifndef __ACTION_FACTORY_H_
#define __ACTION_FACTORY_H_
#include <string>
#include "action.h"
#include "file_operation.h"
#include "operations.h"
#include "rule.h"

using std::string;

namespace 
{
  const string filename_keyword = "__FILE__"; 
  const string new_file_keyword = "__NEW_FILE__"; 
  const string old_file_keyword = "__OLD_FILE__"; 
}

class ActionFactory {

public:
  enum e_action_type { COMMAND, FTP, EXEC, MAIL, RSYNC, MYSQL };
  Action * create_action( FileOperation fo, Rule* rule );
  static ActionFactory * get_instance();

protected:

    ActionFactory();
    ~ActionFactory();

    bool ActionFactory::is_instantiated();
    e_action_type ActionFactory::parse_type( string& line );

private:
    void substitute_keywords( string& line, FileOperation* fo );

    static ActionFactory * m_action_factory;
    bool m_action_factory_instantiated;
};

#endif
