/**
 * The list of pending actions
 */

/*****************************************************************************
     This file is part of the Changedfiles system. 

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
/*  $Id: action_queue.h,v 1.5 2002/03/18 21:10:01 philip Exp $ */
#ifndef _ACTION_QUEUE_H_
#define _ACTION_QUEUE_H_
#include <string> 
#include <list> 
#include <map> 
#include "action.h"
#include "rule.h"
#include <pthread.h> 
#include "logger.h"

using std::string; 
typedef std::list<Action*> ACTION_LIST; 

class ActionQueue
{
 public: 
  
  ActionQueue( Rule* rule ); 
  ~ActionQueue();
  
  bool add_action( Action* ); 

  void action_loop(); 

  Rule* get_rule(){ return m_rule; }; 
  bool start(); 

  bool do_next(); 

 private: 
 
  void * run( void * ); 
  ACTION_LIST m_action_list; 
  Rule* m_rule; 
  string m_rulename;
  int m_max_retry; 
  pthread_mutex_t m_queue_mutex; 
  Logger *m_logger; 

}; 

#endif

  
