/*****************************************************************************
     This file is part of Changedfiles system. 

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/

#ifndef _BANGCONFIG_H_
#define _BANGCONFIG_H_
#include <string> 
#include <map>
#include <time.h> 
#include "rule.h"
#include "operations.h" 
#include "logger.h" 
using std::string; 
typedef std::map<string,Rule*> RULE_MAP; 


class BangConf
{ 
  
 public: 
  BangConf(); 
  BangConf( const string& filename );

  ~BangConf(){}; 
  RULE_MAP get_rules(); 

  string    get_error(); 
  bool      is_valid(); 

 protected: 
  
  bool      read_config( const string& filename); 
  bool      read_config( const char * filename); 
  enum { M_READ_BUF_SIZE = 2048}; 
  RULE_MAP m_rule_map;
  string m_error; 
  bool m_valid; 

  e_optype parse_op_str( const string& op_str ); 
  string parse_rule( const char * line); 
  Logger *m_logger; 
  
}; 

#endif


