/*****************************************************************************
     This file is part of the Changedfiles system. 

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
/*  $Id: bangreader.h,v 1.15 2002/02/01 23:00:57 philip Exp $ */
#ifndef _BANGREADER_H_
#define _BANGREADER_H_
#include <string>
#include <memory> 
#include <list>
#include "file_operation.h"
#include "queue_handler.h"
#include "bangconfig.h"
//#include "pthread.h"
#include "logger.h"

class BangReader 
{ 

 public: 
  BangReader(){}; 
  BangReader(QueueHandler*);
  BangReader(QueueHandler*, std::string); 
  ~BangReader();
  void check_loop(); 
  bool set_que(QueueHandler*);
  std::string get_error(); 
  bool start(); 
  int read_new(); 

 private: 
  
  QueueHandler* m_que;
  string m_device; 
  string m_error; 
  int m_fd; 
  int m_bufsize; 
  Logger *m_logger; 

};
#endif
