/*****************************************************************************
     This file is part of Changedfiles

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
/*  $Id: exec_action.h,v 1.2 2003/09/20 22:15:07 philip Exp $ */
#ifndef __EXECACTION_H_
#define __EXECACTION_H_
#include "action.h"
//#include "action_exception.h"
#include "operations.h" 

#include <string> 


using std::string; 

class ExecAction : public Action
{ 

 public: 

  ExecAction(){}; 
  ExecAction( string command, int max_retry); 
  ExecAction( string command, int max_retry, time_t command_timeout );
  ExecAction( string command, int max_retry, time_t command_timeout, int timeout_retry );
  ~ExecAction(){}; 
  
  string get_command(); 
  bool set_command( string command ); 
  
  bool set_operation( e_optype operation ){ m_operation = operation; return true; };
  e_optype get_operation(){ return m_operation; };
  
  bool set_file( string filename ){ m_filename = filename; return true;};
  string get_file(){ return m_filename; };
  
  bool set_old_file( string oldfilename){ m_oldfilename =  oldfilename; return true; };
  string get_old_file(){ return m_oldfilename; };
  
  bool set_new_file( string newfilename){ m_newfilename = newfilename; return true; };
  string get_new_file(){ return m_newfilename;};

  bool do_action(); // throw ( ActionException );
  string get_description();
  
 private: 
  e_optype m_operation;
  string m_command; 
  string m_filename;
  string m_oldfilename;
  string m_newfilename;
  
}; 


#endif
