/*****************************************************************************
     This file is part of the Changedfiles system. 

     Copright (C)2001  Michael L. Welles

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
/*  $Id: file_operation.h,v 1.8 2003/06/04 18:44:42 mike Exp $ */
#ifndef __FILE_OPERATION_H_
#define __FILE_OPERATION_H_

extern "C" { 
#include <time.h>
#include <sys/types.h>
#include <unistd.h>
}

#include <string>
#include "operations.h" 
#include "logger.h" 

using std::string; 

class FileOperation
{ 

 public:
  FileOperation(){};
  // FileOperation( const string&, const string&, const string& ); 
  // FileOperation( const string&, const string& ); 
  FileOperation( const string, const string, const string ); 

  FileOperation( const string, const string ); 

  ~FileOperation() {}; 
  time_t get_watchtime(); 
  bool   set_watchtime( time_t ); 

  bool   is_open(); 

  bool   is_ready(); 
  bool   is_timeout(); 

  ino_t  get_inode(); 
  dev_t  get_dev(); 
  bool   set_inode(); 
  bool   is_valid(); 

  e_optype get_operation(); 
  bool   set_operation( e_optype ); 

  string  get_filename(); 
  bool    set_filename( string ); 

  string  get_new_file(); 
  bool    set_new_file( string ); 

  string  get_old_file(); 
  bool    set_old_file( string ); 

  bool set_timeout( int t );
  int get_timeout(){ return m_timeout; }
  string  get_rule(); 
  


 private: 

  void set_members( string, string, string );
  time_t m_watchtime; 
  ino_t  m_inode; 
  dev_t  m_dev; 
  e_optype  m_operation; 
  string  m_filename; 
  string m_old_file; 
  string m_new_file; 
  bool m_valid; 
  string m_error; 
  Logger *m_logger; 
  int m_timeout;

}; 

#endif
  
  
  

