/*****************************************************************************
     This file is part of Changedfiles

     Copright (C)2002  Philip Antoniades

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/

#ifndef __FTPACTION_H_
#define __FTPACTION_H_

#include "action.h"
//#include "action_exception.h"
#include "operations.h"
#include "ftp_connection_manager.h"
#include <string> 
extern "C"{
#include <libfget.h>
}

using std::string; 

class FTPAction : public Action
{ 

 public: 

  FTPAction(){}; 
  FTPAction( e_optype optype, string params, int max_retry); // throw (ActionException); 
    FTPAction( e_optype optype, string params, int max_retry, int timeout, int timeout_retry); //throw ( ActionException );
  ~FTPAction(){}; 
  
  bool do_action(); //throw( ActionException );
  string get_description();
  
 private: 
  bool connect();
  bool disconnect();
  bool send_file( string remote_name );
  bool mkdir( string remote_name );
  bool rmdir( string remote_name );
  bool unlink( string remote_name );
  bool rename_file( string remote_name );
  bool parse_params( string params ); //throw (ActionException);
  string get_remote_filename(); // throw (ActionException);
  e_optype m_optype;
  string m_hostname;
  string m_username;
  string m_password;
  string m_filename;
  string m_oldname;
  string m_basename;
  string m_local_dir;
  string m_remote_dir;
  time_t m_cache_expire;
  // cache max size
  long m_cache;
  unsigned short m_flags;
  FTP * m_ftp;
}; 


#endif
