/*****************************************************************************
     This file is part of Changedfiles

     Copright (C)2002  Philip Antoniades

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
#ifndef __FTPCONNECTION_H_
#define __FTPCONNTECTION_H_
#include <string>
#include <map>
extern "C"{
#include <libfget.h>
}
using std::string;
typedef std::map<string,FTP*> CONNECTION_MAP;
class FTPConnectionManager
{ 
public:
  static FTPConnectionManager * get_instance();
  FTP* get_connection( string host, string usernamne, string password );
  bool return_connection( string host, string username, string password, FTP *connection);

protected:
  FTPConnectionManager();
  ~FTPConnectionManager();

private:
  FTP * connect( string hostname, string username, string password );
  bool check_connection( FTP*, string hostname );
  bool disconnect( FTP* );
  bool is_instantiated();
  
  static FTPConnectionManager * m_ftp_connection_manager;
  bool m_ftp_connection_manager_instantiated;
  time_t m_cache_expire;
  // cache max size
  long m_cache;
  unsigned short m_flags;
  CONNECTION_MAP m_connection_map;
};
#endif  






