/*****************************************************************************
     This file is part of Changedfiles

     Copright (C)2002  Philip Antoniades

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
#ifdef _CHANGEDFILES_HAS_MYSQL_
#ifndef __MYSQLACTION_H_
#define __MYSQLACTION_H_

#include "action.h"
//#include "action_exception.h"
#include "operations.h"
#include "mysql_connection_manager.h"
#include <string> 
extern "C"{
#include "/usr/local/mysql/include/mysql/mysql.h"
}

using std::string; 

class MySQLAction : public Action
{ 
 public: 
  MySQLAction(){}; 
  MySQLAction( string params, int max_retry); // throw (ActionException); 
  MySQLAction( string params, int max_retry, int timeout, int timeout_retry); //throw ( ActionException );
  ~MySQLAction(){}; 
  bool do_action(); //throw( ActionException );
  string get_description(){ return "I am a MYSQL Action"; };

 private: 
  bool parse_params( string params );
  bool connect();
  bool disconnect();
  bool do_query();
  string m_hostname;
  string m_username;
  string m_password;
  string m_filename;
  string m_database;
  string m_query;
  MYSQL *m_mysql;
}; 
#endif
#endif
