/*****************************************************************************
     This file is part of Changedfiles

     Copright (C)2002  Philip Antoniades

     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*******************************************************************************/
#ifdef _CHANGEDFILES_HAS_MYSQL_
#ifndef __MYSQLCONNECTION_H_
#define __MYSQLCONNECTION_H_
#include <string>
#include <map>
extern "C"{
#include "/usr/local/mysql/include/mysql/mysql.h"
}
using std::string;
typedef std::map<string, MYSQL*> MYSQL_CONNECTION_MAP;

class MySQLConnectionManager
{ 
public:
  static MySQLConnectionManager * get_instance();
  MYSQL* get_connection( const char *hostname, const char *usernamne, const char *password, const char *database );
  bool return_connection( const char *hostname, const char *username, const char *password, const char *database, MYSQL *mysql);

protected:
  MySQLConnectionManager();
  ~MySQLConnectionManager();

private:
  bool connect( const char * hostname, const char * username, const char *  password, const char * database, MYSQL *mysql );
  bool check_connection( MYSQL *mysql );
  bool disconnect( MYSQL *mysql );
  bool is_instantiated();
  
  static MySQLConnectionManager * m_mysql_connection_manager;
  bool m_mysql_connection_manager_instantiated;
  time_t m_cache_expire;
  // cache max size
  long m_cache;
  unsigned short m_flags;
  MYSQL_CONNECTION_MAP m_connection_map;
};
#endif  
#endif





